<template>
  <v-dialog
    :value="value"
    max-width="290"
    @keydown.esc="closeRequest"
    @click:outside="closeRequest"
    content-class="round"
  >
    <!-- <div class="flex flex-col bg-white p-7 justify-between gap-8">
      <div class="flex-grox flex-row">
        <div class="text-xl font-semibold text-center">
          {{ passedData.title }}
        </div>
      </div>
      <div class="flex flex-col">
        <div>
          <div class="my-5 text-sm">
            <v-form
              lazy-validation
              ref="form"
              v-model="valid"
              @submit.prevent="onModalSubmit(passedData.crud)"
            >
              <v-text-field
                label="Nom"
                id="nom"
                :rules="nomRules"
                required
                v-model="matCompSav.nom"
              ></v-text-field>
              <v-select
                required
                :items="bulletins"
                item-text="nom"
                item-value="bulletin"
                :rules="bulletinRules"
                return-object
                v-model="matCompSav.bulletin"
                label="Bulletin"
                v-if="$props.passedData.type === 'Savoir'"
                no-data-text="Pas de bulletin créé"
              ></v-select>
            </v-form>
          </div>
        </div>
      </div>
      <div class="flex flex-row-reverse justify-between">
        <div>
          <button
            @click="onModalSubmit($props.passedData.crud)"
            class="font-medium bg-bleu text-gray-50 text-sm py-2.5 px-5 rounded-lg hover:bg-bleuHover focus:outline-none"
          >
            {{ updating ? "Modifier" : "Ajouter" }}
          </button>
        </div>
        <div
          id="deleteMatCompSav"
          @click="onModalSubmit('delete')"
          class="cursor-pointer font-medium border border-red-400 text-red-400 text-sm py-2.5 px-5 rounded-lg hover:bg-red-400 hover:text-gray-50 focus:outline-none"
          v-show="updating"
        >
          Effacer
        </div>
      </div>
    </div> -->
  </v-dialog>
</template>

<script>
export default {
  emits: ["closeRequest, onModalSubmit"],
  props: { passedData: Object, value: Boolean },

  methods: {
    closeRequest() {
      this.$emit("closeRequest");
    },
    onModalSubmit(crud) {
      if (this.$refs.form.validate()) {
        this.$emit(
          "onModalSubmit",
          this.matCompSav,
          this.passedData.type,
          crud,
          this.passedData.addingFor
        );
        this.matCompSav = {};
      }
    },
  },

  data() {
    return {
      valid: false,
      matCompSav: { ...this.$props.passedData.matCompSav } || {},
      updating: this.$props.passedData.crud === "update",
      nomRules: [(v) => !!v || "Le nom est requis"],
      bulletinRules: [(v) => !!v || "Le bulletin est requis"],
    };
  },

  computed: {
    bulletins() {
      return this.$store.state.bulletins;
    },
  },
};
</script>
